import 'dart:async';
import 'dart:developer';

import 'package:action_box/action_box.dart';
import 'package:action_box/src/utils/tuple.dart';
// import 'package:rxdart/rxdart.dart';

import 'action_box.dart';

//import 'package:rxdart/rxdart.dart';
// You can use code generator. https://pub.dev/packages/action_box_generator
// If you use a generator, the following files are automatically created.
//  => action descriptor(directory) files : value_converter.dart, action_root.dart
//  => action_box.dart
@ActionBoxConfig(
    //actionRootType: 'ActionRoot', //optional
    generateSourceDir: ['lib', 'example']) //optional
final actionBox = ActionBox.shared(
    // You can use rx dart's operator to avoid duplication of errors.
    // errorStreamFactory: () => PublishSubject()
    // ..bufferTime(Duration(milliseconds: 500))
    //   .where((x) => x.isNotEmpty)
    //   .flatMap((x) =>
    //   (x as PublishSubject<Object>).distinct((pre, cur) => pre == cur))
    )
  ..exceptionStream.listen((event) {
    print('global error handler => $event');
  });

void main() async {
  var bag = DisposeBag();

  //receive result
  // actionBox((a) => a.valueConverter.getStringToListValue)
  //     .map()
  //     .listen((result) {
  //   result?.forEach((v) => print(v));
  // }).disposedBy(bag);

  actionBox((a) => a.valueConverter.getStringToListValue)
      .map(channel: (a) => a.ch1 | a.defaultChannel)
      .listen((result) {
    result?.forEach((v) => print(v));
  }).disposedBy(bag);

  actionBox((a) => a.valueConverter.getStringToListValue)
      .map(channel: (a) => a.ch1)
      .listen((result) {
    result?.forEach((v) => print(v));
  }).disposedBy(bag);

  //request data
  actionBox((a) => a.valueConverter.getStringToListValue).go(
      channel: (c) => c.ch1,
      param: 'value',
      begin: () {/* before dispatching */},
      end: (success) {/* after dispatching */},
      timeout: Duration(seconds: 10));

  actionBox((a) => a.valueConverter.getStringToListValue)
      //.when(() => true, (a) => a.echo(value: ['e', 'c', 'h', 'o']))
      // .when(() => true, (a) => a.echo(value: null))
      //.when(() => true, (a) => a.waste(param: 'ignore'))
      .go(param: 'real value');
  //
  actionBox((a) => a.valueConverter.getStringToListValue).waste(
      param: 'waste',
      end: (success) {
        print(success);
      });

  var errStream = StreamController()..disposedBy(bag);
  errStream.stream.listen((event) {
    print('local => $event');
  }).disposedBy(bag);

  actionBox((a) => a.valueConverter.getStringToCharValue).map().listen((v) {
    print(v);
  }, onError: (error) {
    print('onError => $error');
  });

  actionBox((a) => a.valueConverter.getStringToCharValue).go(
      param: 'This is iterable stream test!',
      errorSinks: (global, pipeline) => [global, pipeline, errStream]);

  await Future.delayed(Duration(seconds: 10));
  //call dispose method when completed
  bag.dispose();
}
